跳到主要内容

与 Angular 集成

提示

使用本文档前,您应熟悉 Angular 的基本概念和模式。如需复习,请参阅 Angular 文档。

DHTMLX Spreadsheet 与 Angular 兼容。我们已准备了如何在 Angular 中使用 DHTMLX Spreadsheet 的代码示例。更多信息请参阅对应的 GitHub 示例。

创建项目​

信息

在开始创建新项目之前,请先安装 Angular CLI 和 Node.js。

使用 Angular CLI 创建一个新的 my-angular-spreadsheet-app 项目。运行以下命令:

ng new my-angular-spreadsheet-app
备注

如果您希望按照本指南操作,在创建新 Angular 应用时请禁用服务端渲染(SSR)和静态站点生成(SSG/Prerendering)。

上述命令会安装所有必要的工具,因此您无需运行任何额外的命令。

安装依赖项​

完成后,进入应用目录:

cd my-angular-spreadsheet-app

安装依赖项并启动开发服务器。为此,请使用 yarn 包管理器:

yarn
yarn start

应用应在 localhost 上运行(例如 http://localhost:3000)。

创建 Spreadsheet​

现在您需要获取 DHTMLX Spreadsheet 源代码。首先停止应用并安装 Spreadsheet 包。

第一步:安装包​

下载 试用版 Spreadsheet 包 并按照 README 文件中的步骤操作。请注意,试用版 Spreadsheet 仅可使用 30 天。

第二步:创建组件​

现在您需要创建一个 Angular 组件,以便将 Spreadsheet 添加到应用中。在 src/app/ 目录下创建 spreadsheet 文件夹,在其中添加一个新文件并命名为 spreadsheet.component.ts。然后完成以下步骤。

导入源文件​

打开该文件并导入 Spreadsheet 源文件。请注意:

  • 如果您使用 PRO 版本并从本地文件夹安装 Spreadsheet 包,导入路径如下:
import { Spreadsheet } from 'dhx-spreadsheet-package';
  • 如果您使用试用版 Spreadsheet,请指定以下路径:
import { Spreadsheet } from '@dhx/trial-spreadsheet';

本教程展示如何配置 试用版 Spreadsheet。

设置容器并初始化 Spreadsheet​

要在页面上显示 Spreadsheet,您需要设置渲染组件的容器并使用相应的构造函数初始化 Spreadsheet:

spreadsheet.component.ts
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: 'spreadsheet', // 模板名称,用于 "app.component.ts" 文件中的 <spreadsheet/>
styleUrls: ['./spreadsheet.component.css'], // 引入 css 文件
template: `<div #container class = "widget"></div>`
})

export class SpreadsheetComponent implements OnInit, OnDestroy {
// 初始化 Spreadsheet 的容器
@ViewChild('container', { static: true }) spreadsheet_container!: ElementRef;

private _spreadsheet!: Spreadsheet;

ngOnInit() {
// 初始化 Spreadsheet 组件
this._spreadsheet = new Spreadsheet( this.spreadsheet_container.nativeElement, {});
}

ngOnDestroy() {
this._spreadsheet.destructor(); // 销毁 Spreadsheet
}
}

添加样式​

要正确显示 Spreadsheet,您需要提供相应的样式。为此,可以在 src/app/spreadsheet/ 目录下创建 spreadsheet.component.css 文件,并为 Spreadsheet 及其容器指定重要样式:

spreadsheet.component.css
/* 导入 Spreadsheet 样式 */
@import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css";

/* 指定初始页面样式 */
html,
body {
height: 100%;
padding: 0;
margin: 0;
}

/* 指定 Spreadsheet 容器样式 */
.widget {
height: 100%;
}

加载数据​

要向 Spreadsheet 中添加数据,您需要提供一个数据集。可以在 src/app/spreadsheet/ 目录下创建 data.ts 文件并添加一些数据:

data.ts
export function getData(): any {
return {
styles: {
bold: {
"font-weight": "bold"
},
right: {
"justify-content": "flex-end",
"text-align": "right"
}
},
data: [
{ cell: "a1", value: "Country", css:"bold" },
{ cell: "b1", value: "Product", css:"bold" },
{ cell: "c1", value: "Price", css:"right bold" },
{ cell: "d1", value: "Amount", css:"right bold" },
{ cell: "e1", value: "Total Price", css:"right bold" },

{ cell: "a2", value: "Ecuador" },
{ cell: "b2", value: "Banana" },
{ cell: "c2", value: 6.68, format: "currency" },
{ cell: "d2", value: 430 },
{ cell: "e2", value: 2872.4, format: "currency" },

{ cell: "a3", value: "Belarus" },
{ cell: "b3", value: "Apple" },
{ cell: "c3", value: 3.75, format: "currency" },
{ cell: "d3", value: 600 },
{ cell: "e3", value: 2250, format: "currency" },

{ cell: "a4", value: "Peru" },
{ cell: "b4", value: "Grapes" },
{ cell: "c4", value: 7.69, format: "currency" },
{ cell: "d4", value: 740 },
{ cell: "e4", value: 5690.6, format: "currency" },

// 更多包含数据的单元格
]
}
}

然后打开 spreadsheet.component.ts 文件。导入数据文件并在 ngOnInit() 方法中使用 parse() 方法应用数据,如下所示。

spreadsheet.component.ts
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: 'spreadsheet',
styleUrls: ['./spreadsheet.component.css'],
template: `<div #container class = "widget"></div>`
})

export class SpreadsheetComponent implements OnInit, OnDestroy {
@ViewChild('container', { static: true }) spreadsheet_container!: ElementRef;

private _spreadsheet!: Spreadsheet;

ngOnInit() {
const data = getData(); // 初始化数据属性
this._spreadsheet = new Spreadsheet( this.spreadsheet_container.nativeElement, {});

this._spreadsheet.parse(data);
}

ngOnDestroy() {
this._spreadsheet.destructor();
}
}

现在 Spreadsheet 组件已可以使用。当元素添加到页面时,它会用数据初始化 Spreadsheet。您也可以根据需要提供配置项。请访问我们的 Spreadsheet API 文档 查看所有可用属性的完整列表。

处理事件​

当用户在 Spreadsheet 中执行操作时,widget 会触发相应事件。您可以使用这些事件检测操作并运行所需代码。请参阅事件完整列表。

打开 spreadsheet.component.ts 文件,按如下方式完成 ngOnInit() 方法:

spreadsheet.component.ts
// ...
ngOnInit() {
this._spreadsheet = new Spreadsheet(this.spreadsheet_container.nativeElement,{});

spreadsheet.events.on("afterFocusSet", function(cell){
console.log("Focus is set on a cell " + spreadsheet.selection.getSelectedCell());
console.log(cell);
});
}

ngOnDestroy() {
this._spreadsheet.destructor();
}

第三步:将 Spreadsheet 添加到应用​

要将 SpreadsheetComponent 组件添加到应用中,打开 src/app/app.component.ts 文件,并将默认代码替换为以下内容:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<spreadsheet/>` // 在 "spreadsheet.component.ts" 文件中创建的模板
})
export class AppComponent {
name = "";
}

然后在 src/app/ 目录下创建 app.module.ts 文件,并按如下方式指定 SpreadsheetComponent:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { SpreadsheetComponent } from "./spreadsheet/spreadsheet.component";

@NgModule({
declarations: [AppComponent, SpreadsheetComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

最后一步是打开 src/main.ts 文件,并将现有代码替换为以下内容:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

完成后,您可以启动应用,在页面上查看加载了数据的 Spreadsheet。

Angular 应用中已加载示例数据的 DHTMLX Spreadsheet

现在您已了解如何将 DHTMLX Spreadsheet 与 Angular 集成。您可以根据具体需求自定义代码。最终示例可在 GitHub 上找到。

跳到主要内容

与 Svelte 集成

提示

在阅读本文档之前,您应该熟悉 Svelte 的基本概念和模式。如需温习相关知识,请参阅 Svelte 文档。

DHTMLX Spreadsheet 与 Svelte 兼容。我们已准备了如何将 DHTMLX Spreadsheet 与 Svelte 配合使用的代码示例。更多信息,请参阅相应的 GitHub 示例。

创建项目​

信息

在开始创建新项目之前,请安装 Vite(可选)和 Node.js。

要创建 Svelte JS 项目,请运行以下命令:

npm create vite@latest

将项目命名为 my-svelte-spreadsheet-app。

安装依赖​

进入应用目录:

cd my-svelte-spreadsheet-app

然后安装依赖并运行应用。请使用包管理器执行以下操作:

  • 如果您使用 yarn,需要执行以下命令:
yarn
yarn dev // or yarn dev
  • 如果您使用 npm,需要执行以下命令:
npm install
npm run dev

应用应在 localhost 上运行(例如 http://localhost:3000)。

创建 Spreadsheet​

现在您需要获取 DHTMLX Spreadsheet 源代码。首先停止应用并安装 Spreadsheet 包。

第一步:安装包​

下载试用版 Spreadsheet 包并按照 README 文件中的步骤操作。请注意,试用版 Spreadsheet 仅可使用 30 天。

第二步:创建组件​

现在您需要创建一个 Svelte 组件,将 Spreadsheet 添加到应用中。在 src/ 目录中创建一个新文件,命名为 Spreadsheet.svelte。

导入源文件​

打开 Spreadsheet.svelte 文件并导入 Spreadsheet 源文件。请注意:

  • 如果您使用专业版并从本地文件夹安装 Spreadsheet 包,导入路径如下:
Spreadsheet.svelte
<script>
import { Spreadsheet } from 'dhx-spreadsheet-package';
import 'dhx-spreadsheet-package/codebase/spreadsheet.css';
</script>

请注意,根据所使用的包,源文件可能已被压缩。此情况下,请确保导入的 CSS 文件为 spreadsheet.min.css。

  • 如果您使用 Spreadsheet 试用版,请指定以下路径:
Spreadsheet.svelte
<script>
import { Spreadsheet } from '@dhx/trial-spreadsheet';
import '@dhx/trial-spreadsheet/codebase/spreadsheet.min.css';
</script>

本教程演示如何配置 Spreadsheet 的试用版本。

设置容器并添加 Spreadsheet​

要在页面上显示 Spreadsheet,您需要创建 Spreadsheet 的容器,并使用相应的构造函数初始化该组件:

Spreadsheet.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css"

let container; // initialize container for Spreadsheet
let spreadsheet;

onMount(() => {
// initialize the Spreadsheet component
spreadsheet = new Spreadsheet(container, {});
});

onDestroy(() => {
spreadsheet.destructor(); // destruct Spreadsheet
});
</script>

<div bind:this={container} class="widget"></div>

添加样式​

为了正确显示 Spreadsheet,您需要在项目的主 CSS 文件中为 Spreadsheet 及其容器指定重要样式:

app.css
/* specify styles for initial page */
html,
body,
#app { /* make sure that you use the #app root container */
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for the Spreadsheet container */
.widget {
height: 100%;
}

加载数据​

要向 Spreadsheet 中添加数据,您需要提供一个数据集。在 src/ 目录中创建 data.js 文件,并向其中添加一些数据:

data.js
export function getData() {
return {
styles: {
bold: {
"font-weight": "bold"
},
right: {
"justify-content": "flex-end",
"text-align": "right"
}
},
data: [
{ cell: "a1", value: "Country", css:"bold" },
{ cell: "b1", value: "Product", css:"bold" },
{ cell: "c1", value: "Price", css:"right bold" },
{ cell: "d1", value: "Amount", css:"right bold" },
{ cell: "e1", value: "Total Price", css:"right bold" },

{ cell: "a2", value: "Ecuador" },
{ cell: "b2", value: "Banana" },
{ cell: "c2", value: 6.68, format: "currency" },
{ cell: "d2", value: 430 },
{ cell: "e2", value: 2872.4, format: "currency" },

{ cell: "a3", value: "Belarus" },
{ cell: "b3", value: "Apple" },
{ cell: "c3", value: 3.75, format: "currency" },
{ cell: "d3", value: 600 },
{ cell: "e3", value: 2250, format: "currency" },

{ cell: "a4", value: "Peru" },
{ cell: "b4", value: "Grapes" },
{ cell: "c4", value: 7.69, format: "currency" },
{ cell: "d4", value: 740 },
{ cell: "e4", value: 5690.6, format: "currency" },

// more cells with data
]
}
}

然后打开 App.svelte 文件,导入数据,并将其作为 props 传递给新创建的 <Spreadsheet/> 组件:

App.svelte
<script>
import Spreadsheet from "./Spreadsheet.svelte";
import { getData } from "./data.js";

const data = getData();
</script>

<Spreadsheet data={data} />

进入 Spreadsheet.svelte 文件,使用 parse() 方法将传入的 props 应用到 Spreadsheet:

Spreadsheet.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css"

export let data;

let container;
let spreadsheet;

onMount(() => {
spreadsheet = new Spreadsheet(container, {});
spreadsheet.parse(data);
});

onDestroy(() => {
spreadsheet.destructor();
});
</script>

<div bind:this={container} class="widget"></div>

现在 Spreadsheet 组件已准备好使用。当元素被添加到页面时,它会使用数据初始化 Spreadsheet。您也可以提供必要的配置设置。请访问我们的 Spreadsheet API 文档查看可用属性的完整列表。

处理事件​

当用户在 Spreadsheet 中执行操作时,widget 会触发相应事件。您可以使用这些事件检测操作并为其运行所需代码。请查看事件完整列表。

打开 Spreadsheet.svelte 并按以下方式完善 onMount() 方法:

Spreadsheet.svelte
<script>
// ...
let spreadsheet;

onMount(() => {
spreadsheet = new Spreadsheet(container, {})

spreadsheet.events.on("afterFocusSet", function(cell){
console.log("Focus is set on a cell " + spreadsheet.selection.getSelectedCell());
console.log(cell);
});
});

onDestroy(() => {
spreadsheet.destructor();
});
</script>

// ...

完成上述步骤后,启动应用时,您应该会看到 Spreadsheet 已在页面上加载数据。

DHTMLX Spreadsheet initialized with sample data in a Svelte application

现在您已完成将 DHTMLX Spreadsheet 与 Svelte 集成的基本设置。您可以根据具体需求自定义代码。您可以在 GitHub 上找到最终示例。

跳到主要内容

与 Vue 集成

提示

阅读本文档前,您应当熟悉 Vue 的基本概念和模式。如需复习相关知识,请参阅 Vue 3 文档。

DHTMLX Spreadsheet 与 Vue 兼容。我们已准备了关于如何在 Vue 3 中使用 DHTMLX Spreadsheet 的代码示例。更多信息请参阅对应的 GitHub 示例。

创建项目​

信息

在开始创建新项目之前,请先安装 Node.js。

要创建一个 Vue 项目,请运行以下命令:

npm create vue@latest

该命令会安装并执行 create-vue,即官方 Vue 项目脚手架工具。详情请参阅 Vue.js 快速上手。

我们将该项目命名为 my-vue-spreadsheet-app。

安装依赖​

进入应用目录:

cd my-vue-spreadsheet-app

安装依赖并启动开发服务器。请使用包管理器执行以下操作:

  • 如果您使用 yarn,请运行以下命令:
yarn
yarn start // or yarn dev
  • 如果您使用 npm,请运行以下命令:
npm install
npm run dev

应用应在 localhost 上运行(例如 http://localhost:3000)。

创建 Spreadsheet​

现在您需要获取 DHTMLX Spreadsheet 的源代码。首先,停止应用并安装 Spreadsheet 包。

第一步:安装包​

下载 试用版 Spreadsheet 包 并按照 README 文件中的步骤操作。请注意,试用版 Spreadsheet 仅可使用 30 天。

第二步:创建组件​

现在您需要创建一个 Vue 组件,以便将 Spreadsheet 添加到应用中。在 src/components/ 目录中创建一个新文件,命名为 Spreadsheet.vue。

导入源文件​

打开 Spreadsheet.vue 文件并导入 Spreadsheet 源文件。请注意:

  • 如果您使用 PRO 版本并从本地文件夹安装 Spreadsheet 包,导入路径如下:
Spreadsheet.vue
<script>
import { Spreadsheet } from 'dhx-spreadsheet-package';
import 'dhx-spreadsheet-package/codebase/spreadsheet.css';
</script>

请注意,根据所使用的包,源文件可能已被压缩。在这种情况下,请确保导入的 CSS 文件为 spreadsheet.min.css。

  • 如果您使用试用版 Spreadsheet,请指定以下路径:
Spreadsheet.vue
<script>
import { Spreadsheet } from '@dhx/trial-spreadsheet';
import '@dhx/trial-spreadsheet/codebase/spreadsheet.min.css';
</script>

本教程将演示如何配置 Spreadsheet 的试用版本。

设置容器并添加 Spreadsheet​

要在页面上显示 Spreadsheet,您需要为 Spreadsheet 创建容器,并使用相应的构造函数初始化该组件:

Spreadsheet.vue
<script>
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css";

export default {
mounted() {
// initialize the Spreadsheet component
this.spreadsheet = new Spreadsheet(this.$refs.container, {});
},

unmounted() {
this.spreadsheet.destructor(); // destruct Spreadsheet
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

添加样式​

要正确显示 Spreadsheet,您需要在项目主 CSS 文件中为 Spreadsheet 及其容器指定重要样式:

main.css
/* specify styles for initial page */
html,
body,
#app { /* make sure that you use the #app root container */
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for the Spreadsheet container */
.widget {
height: 100%;
}

加载数据​

要向 Spreadsheet 中添加数据,您需要提供一个数据集。您可以在 src/ 目录中创建 data.js 文件并向其中添加一些数据:

data.js
export function getData() {
return {
styles: {
bold: {
"font-weight": "bold"
},
right: {
"justify-content": "flex-end",
"text-align": "right"
}
},
data: [
{ cell: "a1", value: "Country", css:"bold" },
{ cell: "b1", value: "Product", css:"bold" },
{ cell: "c1", value: "Price", css:"right bold" },
{ cell: "d1", value: "Amount", css:"right bold" },
{ cell: "e1", value: "Total Price", css:"right bold" },

{ cell: "a2", value: "Ecuador" },
{ cell: "b2", value: "Banana" },
{ cell: "c2", value: 6.68, format: "currency" },
{ cell: "d2", value: 430 },
{ cell: "e2", value: 2872.4, format: "currency" },

{ cell: "a3", value: "Belarus" },
{ cell: "b3", value: "Apple" },
{ cell: "c3", value: 3.75, format: "currency" },
{ cell: "d3", value: 600 },
{ cell: "e3", value: 2250, format: "currency" },

{ cell: "a4", value: "Peru" },
{ cell: "b4", value: "Grapes" },
{ cell: "c4", value: 7.69, format: "currency" },
{ cell: "d4", value: 740 },
{ cell: "e4", value: 5690.6, format: "currency" },

// more cells with data
]
}
}

然后打开 App.vue 文件,导入数据,并使用内部 data() 方法进行初始化。之后,您可以将数据作为 props 传递给新创建的 <Spreadsheet/> 组件:

App.vue
<script>
import Spreadsheet from "./components/Spreadsheet.vue";
import { getData } from "./data";

export default {
components: { Spreadsheet },
data() {
return { data: getData() };
}
};
</script>

<template>
<Spreadsheet :data="data" />
</template>

进入 Spreadsheet.vue 文件,使用 parse() 方法将传入的 props 应用到 Spreadsheet:

Spreadsheet.vue
<script>
import { Spreadsheet } from "@dhx/trial-spreadsheet";
import "@dhx/trial-spreadsheet/codebase/spreadsheet.min.css";

export default {
props: ["data"],

mounted() {
this.spreadsheet = new Spreadsheet(this.$refs.container, {});
this.spreadsheet.parse(this.data);
},

unmounted() {
this.spreadsheet.destructor();
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

现在 Spreadsheet 组件已准备好使用。当元素被添加到页面时,它会使用数据初始化 Spreadsheet。您也可以提供必要的配置项。请访问我们的 Spreadsheet API 文档查看完整的可用属性列表。

处理事件​

当用户在 Spreadsheet 中执行操作时,组件会触发相应事件。您可以使用这些事件来检测操作并为其执行所需代码。请参阅完整的事件列表。

打开 Spreadsheet.vue 并完善 mounted() 方法:

Spreadsheet.vue
<script>
// ...
export default {
// ...
mounted: function() {
this.spreadsheet = new Spreadsheet(this.$refs.container, {});

this.spreadsheet.events.on("afterFocusSet", function(cell){
console.log("Focus is set on a cell");
console.log(cell);
});
}
//...
}
</script>

//...

完成后,您可以启动应用,查看加载了数据的 Spreadsheet 页面。

DHTMLX Spreadsheet initialized with sample data in a Vue 3 application

现在您已了解如何将 DHTMLX Spreadsheet 与 Vue 集成。您可以根据具体需求对代码进行自定义。完整示例可在 GitHub 上找到。